> ## Documentation Index
> Fetch the complete documentation index at: https://docs.incident.io/llms.txt
> Use this file to discover all available pages before exploring further.

# Create Entry

> Create an entry within the catalog. We support a maximum of 50,000 entries per type.

If you call this API with a payload where the external_id and catalog_type_id match an existing entry, the existing entry will be updated.



## OpenAPI

````yaml /openapi/tags/catalog-entries-v3.json post /v3/catalog_entries
openapi: 3.0.3
info:
  description: "This is the API reference for incident.io.\n\nIt documents available API endpoints, provides examples of how to use it, and\ninstructions around things like authentication and error handling.\n\nThe API is hosted at:\n\n- https://api.incident.io/\n\nAnd you will need to create an API key via your [incident.io\ndashboard](https://app.incident.io/settings/api-keys) to make requests.\n\n# Making requests\n\nHere are the key concepts required to make requests to the incident.io API.\n\n## Authentication\n\nFor all requests made to the incident.io API, you'll need an API key.\n\nTo create an API key, head to the incident dashboard and visit [API\nkeys](https://app.incident.io/settings/api-keys). When you create the key, you'll be able to choose what actions it\ncan take for your account: choose carefully, as those roles can only be set\nwhen you first create the key. We'll only show you the token once, so make sure\nyou store it somewhere safe.\n\nAPI keys are global to your incident.io account, and can be managed by anyone\nwho has the right permissions. We display the user that created the API key,\nand the API key will remain valid if that user becomes deactivated.\n\nOnce you have the key, you should make requests to the API that set the\n`Authorization` request header using a \"Bearer\" authentication scheme:\n\n```\nAuthorization: Bearer <YOUR_API_KEY>\n```\n\n## Rate Limits\n\nThe incident.io API enforces rate limits to ensure consistent performance for all users.\n\nThe default rate limit is 1200 requests/minute per API key. This limit applies to most endpoints across the API.\n\nSome endpoints have lower rate limits, particularly those that interact with external third-party systems that impose\ntheir own limitations. These specific limits vary by endpoint, and we recommend relying on the rate-limit error\nresponses to understand usage patterns and implement appropriate retry strategies.\n\nWhen you exceed a rate limit, the API will respond with a `429 Too Many Requests` status code, along with a JSON\nresponse that includes information about the limit and when you can retry:\n\n```json\n{\n    \"type\": \"too_many_requests\",\n    \"status\": 429,\n    \"request_id\": \"b839a403-7704-41c1-bf6a-39a2d68caefa\",\n    \"rate_limit\": {\n        \"name\": \"api_key_name\",\n        \"limit\": 1200,\n        \"remaining\": 0,\n        \"retry_after\": \"Thu, 17 Apr 2025 11:17:18 UTC\"\n    },\n    \"errors\": [\n        {\n            \"code\": \"too_many_requests\",\n            \"message\": \"Too many requests hit the API too quickly. We recommend an exponential backoff of your requests.\"\n        }\n    ]\n}\n```\n\nThe response includes:\n* The name of the API key (`name`)\n* The bucket limit (`limit`)\n* The number of requests remaining (`remaining`)\n* When you can retry requests (`retry_after`)\n\n## Errors\n\nWe use standard HTTP response codes to indicate the status or failure of API\nrequests.\n\nThe API response body will be JSON, and contain more detailed information on the\nnature of the error.\n\nAn example error when a request is made without an API key:\n\n```json\n{\n  \"type\": \"authentication_error\",\n  \"status\": 401,\n  \"request_id\": \"8e3cc412-b49d-4957-9073-2c19d2c61804\",\n  \"errors\": [\n    {\n      \"code\": \"missing_authorization_material\",\n      \"message\": \"No authorization material provided in request\"\n    }\n  ]\n}\n```\n\nNote that the error:\n\n- Contains the HTTP status (`401`)\n- References the type of error (`authentication_error`)\n- Includes a `request_id` that can be provided to incident.io support to help\n\tdebug questions with your API request\n- Provides a list of individual errors, which go into detail about why the error\n\toccurred\n\nThe most common error will be a 422 Validation Error, which is returned when the\nrequest was rejected due to failing validations.\n\nThese errors look like this:\n\n```json\n{\n  \"type\": \"validation_error\",\n  \"status\": 422,\n  \"request_id\": \"631766c4-4afd-4803-997c-cd700928fa4b\",\n  \"errors\": [\n    {\n      \"code\": \"is_required\",\n      \"message\": \"A severity is required to open an incident\",\n      \"source\": {\n        \"field\": \"severity_id\"\n      }\n    }\n  ]\n}\n```\n\nThis error is caused by not providing a severity identifier, which should be at\nthe `severity_id` field of the request payload. Errors like these can be mapped to\nforms, should you be integrating with the API from a user-interface.\n\n## Compatibility\n\nWe won't make breaking changes to existing API services or endpoints, but will\nexpect integrators to upgrade themselves to the latest API endpoints within 3\nmonths of us deprecating the old service.\n\nWe will make changes that are considered backwards compatible, which include:\n\n- Adding new API endpoints and services\n- Adding new properties to responses from existing API endpoints\n- Reordering properties returned from existing API endpoints\n- Adding optional request parameters to existing API endpoints\n- Altering the format or length of IDs\n- Adding new values to enums\n\nIt is important that clients are robust to these changes, to ensure reliable\nintegrations.\n\nAs an example, if you are generating a client using an openapi-generator, ensure\nthe generated client is configured to support unknown enum values, often\nconfigured via the `enumUnknownDefaultCase` parameter.\n\nWhen breaking changes are unavoidable, we'll create a new service version on a\nseparate path, and run them in parallel.\n\nFor example:\n\n- https://api.incident.io/v1/incidents\n- https://api.incident.io/v2/incidents\n\nFor any questions, email support@incident.io.\n"
  title: incident.io
  version: 1.0.0
servers:
  - url: https://api.incident.io
security:
  - BearerAuth: []
tags:
  - description: >
      Manage and browse catalog resources.


      Use the incident.io catalog to track services, teams, product features and
      anything

      else that helps build a map of your organisation. These different
      categories of thing

      become catalog types, and each instance (like a particular service or
      team) is a

      catalog entry.


      Each type is made up of a series of attributes, and each attribute has a
      type. Types

      can even have attributes that refer to other catalog types.


      We automatically create catalog types when you connect an integration,
      such as GitHub

      repositories or PagerDuty services and teams. You can use this API to
      create custom

      types, that are specifically tailored to your organisation.


      Examples might be a 'Service' type with an 'Alert channel' which you can
      point at a

      Slack channel, or 'Team' which specifies its 'Manager' and 'Technical
      Lead' as Slack

      users. You can then use these types to create powerful new workflows.


      Consider using our official [catalog
      importer](https://github.com/incident-io/catalog-importer).

      It can be used to sync catalog data from sources like local files or
      GitHub and push

      them into the incident.io catalog without having to directly interact with
      our public API.
    name: Catalog Entries V3
paths:
  /v3/catalog_entries:
    post:
      tags:
        - Catalog Entries V3
      summary: Create Entry
      description: >-
        Create an entry within the catalog. We support a maximum of 50,000
        entries per type.


        If you call this API with a payload where the external_id and
        catalog_type_id match an existing entry, the existing entry will be
        updated.
      operationId: Catalog V3_CreateEntry
      requestBody:
        content:
          application/json:
            example:
              aliases:
                - lawrence@incident.io
                - lawrence
              attribute_values:
                abc123:
                  array_value:
                    - literal: SEV123
                  value:
                    literal: SEV123
              catalog_type_id: 01FCNDV6P870EA6S7TK1DSYDG0
              external_id: 761722cd-d1d7-477b-ac7e-90f9e079dc33
              name: Primary On-call
              rank: 3
            schema:
              $ref: '#/components/schemas/CatalogCreateEntryPayloadV3'
        required: true
      responses:
        '201':
          content:
            application/json:
              example:
                catalog_entry:
                  aliases:
                    - lawrence@incident.io
                    - lawrence
                  archived_at: '2021-08-17T14:28:57.801578Z'
                  attribute_values:
                    abc123:
                      array_value:
                        - label: Lawrence Jones
                          literal: SEV123
                      value:
                        label: Lawrence Jones
                        literal: SEV123
                  catalog_type_id: 01FCNDV6P870EA6S7TK1DSYDG0
                  created_at: '2021-08-17T13:28:57.801578Z'
                  external_id: 761722cd-d1d7-477b-ac7e-90f9e079dc33
                  id: 01FCNDV6P870EA6S7TK1DSYDG0
                  name: Primary On-call
                  rank: 3
                  updated_at: '2021-08-17T13:28:57.801578Z'
              schema:
                $ref: '#/components/schemas/CatalogCreateEntryResultV3'
          description: Created response.
components:
  schemas:
    CatalogCreateEntryPayloadV3:
      example:
        aliases:
          - lawrence@incident.io
          - lawrence
        attribute_values:
          abc123:
            array_value:
              - literal: SEV123
            value:
              literal: SEV123
        catalog_type_id: 01FCNDV6P870EA6S7TK1DSYDG0
        external_id: 761722cd-d1d7-477b-ac7e-90f9e079dc33
        name: Primary On-call
        rank: 3
      properties:
        aliases:
          description: Optional aliases that can be used to reference this entry
          example:
            - lawrence@incident.io
            - lawrence
          items:
            example: abc123
            type: string
          type: array
        attribute_values:
          additionalProperties:
            $ref: '#/components/schemas/CatalogEngineParamBindingPayloadV3'
          description: Values of this entry
          example:
            abc123:
              array_value:
                - literal: SEV123
              value:
                literal: SEV123
          type: object
        catalog_type_id:
          description: ID of this catalog type
          example: 01FCNDV6P870EA6S7TK1DSYDG0
          type: string
        external_id:
          description: >-
            An optional alternative ID for this entry, which is ensured to be
            unique for the type
          example: 761722cd-d1d7-477b-ac7e-90f9e079dc33
          type: string
        name:
          description: Name is the human readable name of this entry
          example: Primary On-call
          type: string
        rank:
          description: When catalog type is ranked, this is used to help order things
          example: 3
          format: int32
          type: integer
      required:
        - catalog_type_id
        - name
        - attribute_values
      type: object
    CatalogCreateEntryResultV3:
      example:
        catalog_entry:
          aliases:
            - lawrence@incident.io
            - lawrence
          archived_at: '2021-08-17T14:28:57.801578Z'
          attribute_values:
            abc123:
              array_value:
                - label: Lawrence Jones
                  literal: SEV123
              value:
                label: Lawrence Jones
                literal: SEV123
          catalog_type_id: 01FCNDV6P870EA6S7TK1DSYDG0
          created_at: '2021-08-17T13:28:57.801578Z'
          external_id: 761722cd-d1d7-477b-ac7e-90f9e079dc33
          id: 01FCNDV6P870EA6S7TK1DSYDG0
          name: Primary On-call
          rank: 3
          updated_at: '2021-08-17T13:28:57.801578Z'
      properties:
        catalog_entry:
          $ref: '#/components/schemas/CatalogEntryV3'
      required:
        - catalog_entry
      type: object
    CatalogEngineParamBindingPayloadV3:
      example:
        array_value:
          - literal: SEV123
        value:
          literal: SEV123
      properties:
        array_value:
          description: If set, this is the array value of the step parameter
          example:
            - literal: SEV123
          items:
            $ref: '#/components/schemas/CatalogEngineParamBindingValuePayloadV3'
          type: array
        value:
          $ref: '#/components/schemas/CatalogEngineParamBindingValuePayloadV3'
      type: object
    CatalogEntryV3:
      properties:
        aliases:
          description: Optional aliases that can be used to reference this entry
          example:
            - lawrence@incident.io
            - lawrence
          items:
            example: abc123
            type: string
          type: array
        archived_at:
          description: When this entry was archived
          example: '2021-08-17T14:28:57.801578Z'
          format: date-time
          type: string
        attribute_values:
          additionalProperties:
            $ref: '#/components/schemas/CatalogEntryEngineParamBindingV3'
          description: Values of this entry
          example:
            abc123:
              array_value:
                - label: Lawrence Jones
                  literal: SEV123
              value:
                label: Lawrence Jones
                literal: SEV123
          type: object
        catalog_type_id:
          description: ID of this catalog type
          example: 01FCNDV6P870EA6S7TK1DSYDG0
          type: string
        created_at:
          description: When this entry was created
          example: '2021-08-17T13:28:57.801578Z'
          format: date-time
          type: string
        external_id:
          description: >-
            An optional alternative ID for this entry, which is ensured to be
            unique for the type
          example: 761722cd-d1d7-477b-ac7e-90f9e079dc33
          type: string
        id:
          description: ID of this catalog entry
          example: 01FCNDV6P870EA6S7TK1DSYDG0
          type: string
        name:
          description: Name is the human readable name of this entry
          example: Primary On-call
          type: string
        rank:
          description: When catalog type is ranked, this is used to help order things
          example: 3
          format: int32
          type: integer
        updated_at:
          description: When this entry was last updated
          example: '2021-08-17T13:28:57.801578Z'
          format: date-time
          type: string
      required:
        - id
        - catalog_type_id
        - name
        - aliases
        - rank
        - attribute_values
        - created_at
        - updated_at
      type: object
    CatalogEngineParamBindingValuePayloadV3:
      example:
        literal: SEV123
      properties:
        literal:
          description: If set, this is the literal value of the step parameter
          example: SEV123
          type: string
      type: object
    CatalogEntryEngineParamBindingV3:
      example:
        array_value:
          - label: Lawrence Jones
            literal: SEV123
        value:
          label: Lawrence Jones
          literal: SEV123
      properties:
        array_value:
          description: If the attribute is multi-valued, the value will be returned here.
          example:
            - label: Lawrence Jones
              literal: SEV123
          items:
            $ref: '#/components/schemas/CatalogEntryEngineParamBindingValueV3'
          type: array
        value:
          $ref: '#/components/schemas/CatalogEntryEngineParamBindingValueV3'
      type: object
    CatalogEntryEngineParamBindingValueV3:
      example:
        label: Lawrence Jones
        literal: SEV123
      properties:
        label:
          description: >-
            A label for this attribute value. If the attribute refers to another
            Catalog entry, this will be the name of that entry.
          example: Lawrence Jones
          type: string
        literal:
          description: >-
            The underlying value of the attribute, serialized as a string.


            For String, Text, Number, and Bool typed attributes, this will be
            empty. For attributes that refer to another catalog entry, this can
            be the ID, external ID, or one of the aliases of that catalog entry.
          example: SEV123
          type: string
      required:
        - label
      type: object
  securitySchemes:
    BearerAuth:
      type: http
      scheme: bearer
      description: API key from your incident.io dashboard (Settings → API keys)

````